Attribute VB_Name = "RunAllJunkRules"
Sub RunAllJunkRules()

'=================================================================
'Description: Outlook macro to run all message rules with
'              "Junk" in their name against the Junk E-mail folder
'
' author : Robert Sparnaaij
' version: 1.0
' website: http://www.howto-outlook.com/howto/junkrules.htm
'=================================================================

    Dim st As Outlook.Store
    Dim myRules As Outlook.Rules
    Dim rl As Outlook.Rule
    Dim ruleList As String
    Dim fldJunk As Outlook.Folder
    'On Error Resume Next
     
    ' get default store (where rules live)
    Set st = Application.Session.DefaultStore
    ' get rules
    Set myRules = st.GetRules
    ' get Junk e-mail folder
    Set fldJunk = st.GetDefaultFolder(olFolderJunk)
     
    ' iterate all the rules
    For Each rl In myRules
        ' determine if it's an Inbox rule
        If rl.RuleType = olRuleReceive Then
            ' determine if it is a Junk rule
            If InStr(LCase(rl.Name), "junk") > 0 Then
            ' if so, run it against the Junk E-mail folder
                rl.Execute ShowProgress:=True, Folder:=fldJunk
                ruleList = ruleList & vbCrLf & rl.Name
            End If
        End If
    Next
     
    ' tell the user what you did
    ruleList = "These rules were executed against the " & _
          "Junk E-mail folder: " & vbCrLf & ruleList
    MsgBox ruleList, vbInformation, "Macro: RunAllJunkRules"
     
    Set rl = Nothing
    Set st = Nothing
    Set myRules = Nothing
    Set fldJunk = Nothing

End Sub

